;Data
;______________________________________________________________________________


;GDT
;______________________________________________________________________________

					align 4
GDTaddress:			dw 0								;0x0000 - Start of GDT null selector
GDT:					dw GDTend - GDTaddress - 1			;GDT Limit
					dd GDTaddress

					dw 0xFFFF,0x0000					;0x0008 - 16-bit code
					dw 0x9B00,0x0000					;base = 0x00000000, limit = 64 KiB, read/execute

					dw 0xFFFF,0x0000					;0x0010 - 16-bit data
					dw 0x9300,0x0000					;base = 0x00000000, limit = 64 KiB, read/write

					dw 0xFFFF,0x0000					;0x0018 - 32-bit code
					dw 0x9B00,0x00CF					;base = 0, limit = 4 GiB, read/write

					dw 0xFFFF,0x0000					;0x0020 - 32-bit data
					dw 0x9300,0x00CF					;base = 0, limit = 4 GiB, read/write
GDTend:
 

;IDTs
;______________________________________________________________________________

					align 2

BIOS_IDT:				dw 256*4-1
					dd 0

NULL_IDT:				dw 0
					dd 0

BBW_IDT:				dw 32*8-1
					dd END

;IDT Data
;______________________________________________________________________________

;Note: This is in a "compressed" format to save space.

					align 2
IDTdata:				dw IDT00
					dw IDT01
					dw IDT02
					dw IDT03
					dw IDT04
					dw IDT05
					dw IDT06
					dw IDT07
					dw IDT08
					dw IDT09
					dw IDT0A
					dw IDT0B
					dw IDT0C
					dw IDT0D
					dw IDT0E
					dw IDT0F
					dw IDT10
					dw IDT11
					dw IDT12
					dw IDT13
					dw IDT14
					dw IDT15
					dw IDT16
					dw IDT17
					dw IDT18
					dw IDT19
					dw IDT1A
					dw IDT1B
					dw IDT1C
					dw IDT1D
					dw IDT1E
					dw IDT1F
