;To assemble:
;  nasm 0index.asm -o test.img
;
;Note: Assemble the boot wrapper first(!)
;______________________________________________________________________________


;WARNING: THIS CODE IS EXTREMELY BAD AND ONLY INTENDED FOR TESTING. DO NOT
;         USE!


;Index file
;______________________________________________________________________________

	org 0x7C00

	jmp 0x0000:START

;BPB or whatever..

START:
	xor ax,ax
	mov ds,ax
	mov es,ax
	cli
	mov ss,ax
	mov sp,0x7C00
	sti


;Load BBW

	mov ah,0x02						;ah = BIOS "read sectors" function
	mov al,(BBW_end - BBW + 511)/512		;al = number of sectors to read
	mov cx,(0 * 256) + 2				;ch = starting cylinder, cl = starting sector
	xor dh,dh							;dh = head number
									;dl = drive number (set by BIOS already)
	mov bx,0x1000						;es:bx = address to load it
	int 0x13
	jc .die							;Lock up if there was an error(!)

	mov edi,.return32					;edi = address of 32-bit code to return to
	jmp 0x0000:0x1004					;Jump to BBW entry point

	bits 32


;32-bit code (with BIOS functions and BIOS IRQs!)
;______________________________________________________________________________

.return32:

;Silly testing stuff..

	mov ax,(0 * 256) + 0x03				;ah = BIOS "set video mode" function, al = video mode
	int 0x10							;Set the video mode

	int 0x12							;Get "number of KiB of RAM at 0x0000000"

	mov ax,(0x0E * 256) + 'H'
	xor bh,bh
	int 0x10							;Display 'H'

	mov ax,(0x0E * 256) + 'i'
	xor bh,bh
	int 0x10							;Display 'i'

	mov ax,(0x0E * 256) + '!'
	xor bh,bh
	int 0x10							;Display '!'


;Lock up

.die:
	hlt
	jmp .die

;End of sector

	times ($$-$+0x01FE) int3
	dw 0xAA55

;Next sector/s

BBW:
	incbin "../bbw/bbw.bin"
BBW_end:

